(defclass Poblacions
  (is-a USER)
  (role abstract)
  (slot habitants (type INTEGER) (create-accessor read-write))
  (slot superficie (type INTEGER) (create-accessor read-write))
  (slot grau_seguretat (type INTEGER) (range 0 10) (default 5) (create-accessor read-write))
)


(defclass Industrials
  (is-a Poblacions)
  (role concrete)
  (pattern-match reactive)
  (slot grau_seguretat (source composite) (default 3))
  (slot sector (type SYMBOL) (create-accessor read-write))
)

(defclass Serveis
  (is-a Poblacions)
  (role abstract)
  (slot periode (type SYMBOL) (allowed-values hivern primavera estiu tardor any) (create-accessor read-write))
)

(defclass Turistic
  (is-a Serveis)
  (role concrete)
  (pattern-match reactive)
  (slot periode (source composite) (default estiu))
)

(defclass Comerc
  (is-a Serveis)
  (role concrete)
  (pattern-match reactive)
  (slot periode (source composite) (default any))
)

(defclass TuristicComerc
  (is-a Turistic Comerc)
  (role concrete)
)

(defclass IndustrialsServeis
  (is-a Industrials Serveis)
  (role concrete)
)

  