;;; Netegem l'entorn CLIPS
(clear)

;;; Carregem el fitxer amb la jerarquia de classes
(load "poblacions.clp")

(make-instance SantaTecla of IndustrialsServeis (habitants 20150) (sector textil) (superficie 25))
(make-instance SantJacint of TuristicComerc (habitants 8532) (periode tardor) (superficie 30))
(make-instance SantLlorenc of Turistic (habitants 1232) (periode primavera) (grau_seguretat 9) (superficie 40))
(make-instance SantaMisericordia of Comerc (habitants 90000) (superficie 1000) (grau_seguretat 2) (periode tardor))
(make-instance SantMagi of Industrials (habitants 350000) (superficie 30) (sector quimic))

;; Instancies extra per provar totes les regles
(make-instance Virgili of Industrials (habitants 252300) (superficie 23) (sector quimic) (grau_seguretat 4))
(make-instance Monte of Comerc (habitants 9055000) (superficie 10) (grau_seguretat 7) (periode hivern))
(make-instance Rovira of IndustrialsServeis (habitants 150) (sector textil) (superficie 25) (grau_seguretat 10))
(make-instance Bor of Comerc (habitants 4000) (superficie 400) (grau_seguretat 6) (periode any))



(defrule sumar1000
  ?obj <- (object (is-a IndustrialsServeis) (habitants ?h))
  =>
  (send ?obj put-habitants (+ ?h 10000))
  (printout T "He sumat 10000 habitants a " (instance-name ?obj) ", ara t " ?h " habitants." crlf)
)

; Calculem la densitat de la poblaci en el moment amb (/ ?h ?s)
(defrule mostrar
  ?obj <- (object (is-a Poblacions) (superficie ?s) (habitants ?h &: (> (/ ?h ?s) 100)) )
  =>
  (printout T (instance-name ?obj) " t " ?h " habitants, una superfcie de " ?s " quilmetres quadrats i una densitat de poblaci " (/ ?h ?s)  crlf)
)


(defrule restar
  ; Ens asegurem que al restar-li 2 ens dona un resultat dintre del rang 0-10, sino no restem
  ?obj <- (object (is-a Industrials) (grau_seguretat ?g &:(< -1 (- ?g 2))) (sector quimic))
  =>
  (send ?obj put-grau_seguretat (- ?g 2))
  (printout T "He restat 2 punts al grau de seguretat de " (instance-name ?obj) ", que ara t un grau de seguretat " (- ?g 2) crlf)
)

(defrule mesHabitants
  ; Si hi ha dues poblacions amb les mateixes poblacions maximes, s'aplicar a totes dues la regla
  ?obj <- (object (is-a Poblacions) (habitants ?h))
  (not (object (is-a Poblacions) (habitants ?h2 &:(> ?h2 ?h))))
  =>
  (printout T (instance-name ?obj) " es la poblaci amb ms habitants, concretament " ?h crlf)
)


(defrule esborrarPoblacions
  ; Ens asegurem que no sigui turistic amb ~Turistic, ja que una instancia de Turistic-Comer podria ser seleccionada
  ; nomes amb (is-a Comer) ja que hereda d'aquest tipus.
  ?obj <- (object (is-a Comerc & ~Turistic))
  =>
  ; Hem de fer el printout abans d'esborrar-lo, sino no podriem imprimir el nom de la instancia
  (printout T "He esborrat " (instance-name ?obj) ", que era una poblaci comercial no turstica." crlf)
  (send ?obj delete)
)


(defrule mateixSector
  ; Per evitar que la regla s'apliqui a una mateixa instancia (ja que ella amb si mateixa te el mateix sector)
  ; comprovem el nom de les instancies escollides siguin diferents.
  ?obj1 <- (object (is-a Industrials) (name ?n) (sector ?s1))
  ?obj2 <- (object (is-a Industrials) (name ?n2 &: (neq ?n ?n2)) (sector ?s2 &:(eq ?s1 ?s2)))
  =>
  (printout T (instance-name ?obj1) " i " (instance-name ?obj2) " tenen el mateix sector d'activitat: " ?s1 crlf)
)

